//////////////////////////////////////////////////////////////////////////////
// Routinen zum Abfragen des WII Nunchuk
// für das Spiel Asteorids
//
// Ulrich Schmerold
// 10/2017
// veröffentlicht in der MAKE 6/2017
//////////////////////////////////////////////////////////////////////////////

#include <Wire.h>
#include <wiinunchuck.h>
int drive = 0;

void init_Nunchuk() { 
  nunchuk_init();
  delay(100);
  nunchuk_calibrate_joy();
  delay(100);
}


boolean get_Firebutton()
{
  nunchuk_get_data();
  return( nunchuk_zbutton());
}

boolean get_CButton()
{
  nunchuk_get_data();
  return(nunchuk_cbutton());
}



// Steuerung von Androids über den WII Nunchuk
void PollNunchuk()
{
  byte tmpx;
  byte tmpy;
  byte shipXold, shipYold;
  int x, y;
  byte drive=0;
  static unsigned long lastHigh;
  static unsigned long lastChange;
  static byte LastShipOrientation;
  
 nunchuk_get_data();
 
 tmpy = nunchuk_cjoy_y();
 tmpx = nunchuk_cjoy_x();
 buttonC = nunchuk_cbutton(); 
 buttonZ = nunchuk_zbutton();
 
 if (buttonZ == HIGH) 
 {
   if ((lastHigh+100) > millis()) buttonZ = LOW;
    else  lastHigh = millis();
 }
 
 shipXold = shipX;
 shipYold = shipY;
 
   if (tmpx > 200) x = 1;
    else   if (tmpx < 60)  x = -1;
     else  x = 0;

  if (tmpy > 200) y = -1;
   else   if (tmpy < 60)  y = 1;
    else y = 0;

  if ((lastChange+100) < millis()) drive = 2; else drive = 0;
  
  LastShipOrientation = shipOrientation;
  
  if ((x== 0) & (y==-1)){shipOrientation=1; shipY -= drive;}              
  if ((x==-1) & (y==-1)){shipOrientation=2; shipY -= drive; shipX -=drive;}
  if ((x==-1) & (y== 0)){shipOrientation=3; shipX -= drive;}
  if ((x==-1) & (y== 1)){shipOrientation=4; shipY += drive; shipX -=drive;}
  if ((x== 0) & (y== 1)){shipOrientation=5; shipY += drive;}
  if ((x== 1) & (y== 1)){shipOrientation=6; shipY += drive; shipX +=drive;}
  if ((x== 1) & (y== 0)){shipOrientation=7; shipX += drive;}
  if ((x== 1) & (y==-1)){shipOrientation=8; shipY -= drive; shipX +=drive;}

  if (LastShipOrientation != shipOrientation)lastChange=millis();
   
  // Schiff berührt Spielfeldrand
  if ((shipX > (W-6)) |(shipX < 6) | (shipY > (H-6)) | (shipY < 6) )
  {
    shipY = shipYold;
    shipX = shipXold;
   }
 }



